<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class usermodel extends CI_Model {
    function __construct() {
        parent::__construct();
    }
    
    /*
     * verify user get user info from database
     * @param $userInfo array
     * return $result array //user information
     */
    public function verifyUser($userInfo){
        if(!empty($userInfo)){
            $username   = $userInfo['username'];
            $password   = $userInfo['password'];
            
            
            $query      = "SELECT * FROM people WHERE userid ='".$username."' AND password='".$password."' AND (role = 1 OR role = 3) LIMIT 1";
            
            $result     = $this->db->conn_id->prepare($query);
            $result->execute();
            if($result->rowCount()>0){
                $row    = $result->fetch(PDO::FETCH_OBJ);
                return $row;
            }else{
                
                return '';
            }
        }
    }
    
    public function getStudents($schoolid){
        
        $query = "SELECT * FROM people WHERE role = 2 AND schoolid = :schoolid";
        $result     = $this->db->conn_id->prepare($query);
        $result->execute(array(':schoolid'=> $schoolid));
        if($result->rowCount()>0){
            $rows    = $result->fetchAll(PDO::FETCH_ASSOC);
            
            return $rows;
        }else{

            return '';
        }
    }
    
    public function createStudent($dataArray){
        $fieldname = '';
        $imageName = '';
        if(isset($dataArray['file']) && $dataArray['file']!==''){
            $fieldname = ',icon';
            $imageName = ',"'.$dataArray['file'].'"';
        }
        
        $classData    = $this->getSchoolLevels($this->session->userdata['schoolid']);
        foreach ($classData as $key => $val){
            
            $arr = explode('-', $val['levels']);
            if(!empty($arr)){
               $newarray = array_slice($arr, 1, -1);
               $levels = count($newarray);
            }
            
        }
        $query = "INSERT INTO people
                        (userid,password,firstname,surname,email,role,schoolid,settingsid,schoollevel".$fieldname.",level)
                        VALUES('".$dataArray['userid']."','".$dataArray['password']."','".$dataArray['firstname']."','".$dataArray['surname']."','".$dataArray['email']."',2,".$this->session->userdata['schoolid'].",1,'".$dataArray['level']."'".$imageName.",".$dataArray['level'].")";
        $result     = $this->db->conn_id->prepare($query);
        $result->execute();
        $id = $this->db->insert_id();
        $query = "SELECT * FROM people WHERE role = 2 AND id='".$id."'";
        $result     = $this->db->conn_id->prepare($query);
        $result->execute();
        if($result->rowCount()>0){
            $rows['data']    = $result->fetch(PDO::FETCH_ASSOC);
            
            echo json_encode($rows);
        }else{

            return '';
        }
        
    }
    public function updateStudent($dataArray){
        $fieldname = '';
        $imageName = '';
        if(isset($dataArray['file']) && $dataArray['file']!==''){
            $fieldname = ',icon';
            $imageName = '"'.$dataArray['file'].'"';
        }
        $query = " Update people 
                        SET userid         = '".$dataArray['userid']."',
                            password       = '".$dataArray['password']."',
                            firstname      = '".$dataArray['firstname']."',
                            surname        = '".$dataArray['surname']."',
                            schoollevel    = '".$dataArray['level']."',
                            level          = '".$dataArray['level']."',
                            email          = '".$dataArray['email']."'
                            ".$fieldname." = ".$imageName." 
                        WHERE
                            id          = ".$dataArray['id'];
        $result     = $this->db->conn_id->prepare($query);
        $result->execute();
        
        $query = "SELECT * FROM people WHERE role = 2 AND id='".$dataArray['id']."'";
        $result     = $this->db->conn_id->prepare($query);
        $result->execute();
        if($result->rowCount()>0){
            $rows['data']    = $result->fetch(PDO::FETCH_ASSOC);
            
            echo json_encode($rows);
        }else{

            return '';
        }
        
    }
    
    public function getStudentById($id){
        
        $query = "SELECT * FROM people WHERE userid= '".$id."'";
        $result     = $this->db->conn_id->prepare($query);
        $result->execute();
        
        if($result->rowCount()>0){
            $row    = $result->fetch(PDO::FETCH_ASSOC);
            return $row;
        }else{

            return '';
        }
        
    }
    
    /*
     * Teacher section function started
     */
    
    public function getTeachers($schoolid){
        $query = "SELECT * FROM people WHERE role = 1 AND schoolid = :schoolid";
        $result     = $this->db->conn_id->prepare($query);
        $result->execute(array('schoolid'=>$schoolid));
        if($result->rowCount()>0){
            $rows    = $result->fetchAll(PDO::FETCH_ASSOC);
            
            return $rows;
        }else{

            return '';
        }
    }
    
    public function createTeacher($dataArray){
        
        $subjects ='';
        $groups   = '';
        if(!empty($dataArray['subject'])){
            $subjects = '-';
            foreach($dataArray['subject'] as $key => $val){
                $subjects .= $val;
                $subjects .= '-';
            }
        }
        if(!empty($dataArray['group'])){
            $groups = '-';
            foreach($dataArray['group'] as $key => $val){
                $groups .= $val;
                $groups .= '-';
            }
        }
        
        $query = "INSERT INTO people
                        (userid,password,firstname,surname,email,groups,role,schoolid,settingsid,subjects)
                        VALUES('".$dataArray['userid']."','".$dataArray['password']."','".$dataArray['firstname']."','".$dataArray['surname']."','".$dataArray['email']."','".$groups."',1,".$this->session->userdata['schoolid'].",1,'".$subjects."')";
        $result     = $this->db->conn_id->prepare($query);
        $result->execute();
        $id = $this->db->insert_id();
        $query = "SELECT * FROM people WHERE role = 1 AND id='".$id."'";
        $result     = $this->db->conn_id->prepare($query);
        $result->execute();
        if($result->rowCount()>0){
            $rows['data']    = $result->fetch(PDO::FETCH_ASSOC);
            
            echo json_encode($rows);
        }else{

            return '';
        }
        
    }
    public function updateTeacher($dataArray){
        $fieldname = '';
        $imageName = '';
        if(isset($dataArray['file']) && $dataArray['file']!==''){
            $fieldname = ',icon';
            $imageName = '"'.$dataArray['file'].'"';
        }
        $subjectString ='';
        $groupString   = '';
        if(!empty($dataArray['subject'])){
            $subjects = '-';
            foreach($dataArray['subject'] as $key => $val){
                $subjects .= $val;
                $subjects .= '-';
            }
            $subjectString = "subjects = '".$subjects."',";
        }
        if(!empty($dataArray['group'])){
            $groups = '-';
            foreach($dataArray['group'] as $key => $val){
                $groups .= $val;
                $groups .= '-';
            }
            $groupString = "groups = '".$groups."',";
        }
        $query = " Update people 
                        SET userid         = '".$dataArray['userid']."',
                            password       = '".$dataArray['password']."',
                            firstname      = '".$dataArray['firstname']."',
                            surname        = '".$dataArray['surname']."',
                            ".$subjectString.$groupString."
                            email          = '".$dataArray['email']."'
                             
                        WHERE
                            id             = ".$dataArray['id'];
        $result     = $this->db->conn_id->prepare($query);
        $result->execute();
        
        $query      = "SELECT * FROM people WHERE role = 1 AND id='".$dataArray['id']."'";
        $result     = $this->db->conn_id->prepare($query);
        $result->execute();
        if($result->rowCount()>0){
            $rows['data']    = $result->fetch(PDO::FETCH_ASSOC);
            
            echo json_encode($rows);
        }else{

            return '';
        }
        
    }
    
    public function getTeacherById($id){
        
        $query      = "SELECT * FROM people WHERE id= ".$id;
        $result     = $this->db->conn_id->prepare($query);
        $result->execute();
        
        if($result->rowCount()>0){
            $row    = $result->fetch(PDO::FETCH_ASSOC);
            return $row;
        }else{

            return '';
        }
        
    }
    
    public function getSchoolLevels($schoolid){
        $sql        = "SELECT schoollevels,levels FROM schools WHERE id = ".$schoolid." ORDER BY name ASC";
        $result     = $this->db->conn_id->prepare($sql);
        $result->execute();
        if($result->rowCount()>0){
            $rows   = $result->fetchAll(PDO::FETCH_ASSOC);
            return $rows;
        }else{
            return '';
        }
    }
    
    public function getSubjectList(){
        $sql        = "SELECT id,name FROM subjects ORDER BY name ASC";
        $result     = $this->db->conn_id->prepare($sql);
        $result->execute();
        if($result->rowCount()>0){
            $rows = $result->fetchAll(PDO::FETCH_ASSOC);
            return $rows;
        }else{
            return '';
        }
    }
    
    public function getGroupList(){
        $sql        = "SELECT id,name FROM groups ORDER BY name ASC";
        $result     = $this->db->conn_id->prepare($sql);
        $result->execute();
        if($result->rowCount()>0){
            $rows = $result->fetchAll(PDO::FETCH_ASSOC);
            return $rows;
        }else{
            return '';
        }
    }
}